module Tut11 where

import Data.List (nub)
import Test.QuickCheck
import qualified AssocList as AL
import qualified Data.Map as DM

{-T12.1.2-}
-- Write your tests for AssocList here.

{-T12.2-}
data Term = App Term Term | Abs String Term | Var String

instance Show Term where
  show (Var x) = x
  show (Abs x t) = "(\\" ++ x ++ " -> " ++ show t ++ ")"
  show (App t1 t2@(App _ _)) = show t1 ++ " (" ++ show t2 ++ ")"
  show (App t1 t2) = show t1 ++ " " ++ show t2

freeVars :: Term -> [String]
freeVars = undefined 

substVar :: String -> Term -> Term -> Term
substVar = undefined

-- Useful functions to implement capture avoiding substitution
varNames :: [String]
varNames = tail vns
  where
    vns = "" : [c:v | v <- vns, c <- ['a'..'z']]

freshVarnames :: Term -> [String]
freshVarnames t = [v | v <- varNames, v `notElem` freeVars t]
